package cn.com.qmth.examcloud.web.filestorage;

import java.io.File;
import java.io.InputStream;

public interface FileStorage {
	
	/**保存文件到存储服务
	 * @param siteId 
	 * @param env
	 * @param file 文件流
	 * @param md5 文件MD5 可为空
	 * @return 返回路径
	 */
	public YunPathInfo saveFile(String siteId,FileStoragePathEnvInfo env,InputStream in,String md5);
	
	/**保存文件到存储服务
	 * @param siteId 
	 * @param env
	 * @param file 文件
	 * @param md5 文件MD5 可为空
	 * @return 返回路径
	 */
	
	public YunPathInfo saveFile(String siteId,FileStoragePathEnvInfo env,File file,String md5);
	
	/**获取可直接访问的文件地址
	 * @param path 全路径，包含根目录，含协议名
	 * @return 返回可直接访问的地址
	 */
	public String realPath(String path);
	
	/**获取可直接访问的文件地址(备用域名地址)
	 * @param path 全路径，包含根目录，含协议名
	 * @return 返回可直接访问的地址,如果没有配置备用地址，则返回主域名地址
	 */
	public String realPathBackup(String path);
	
	/**保存文件到存储服务,siteId为1,转换接口用
	 * @param file 文件
	 * @param path 全路径，含协议名
	 * @return 返回路径
	 */
	public YunPathInfo saveFile(File file, String path);
	
	/**获取云存储签名
	 * @param siteId
	 * @param env
	 * @param md5
	 * @return
	 */
	public YunHttpRequest  getSignature(String siteId,FileStoragePathEnvInfo env,String md5);
	
	/**删除文件
	 * @param path 全路径，含协议名
	 */
	public void deleteFile(String path) ;
	
}
